/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.awt.*;
import java.util.Vector;
import java.awt.event.*;

/** GraphWindow is a GUI-related class used to show a MusicGraph in a
    separate window. */

public class GraphWindow extends Frame {

    public static void main(String[] args) {
	if (args.length<1) {
	    System.out.println("Usage: java GraphWindow <midifile name>");
	    return;
	}
	new GraphWindow(new MotherGraph(args[0],true),100,100,false);
    }

    GraphGui gg;

    public GraphWindow(MotherGraph mgraph, int locx, int locy, boolean seq) {
	super(mgraph.title);
	gg=new GraphGui(mgraph,seq);

	setLocation(locx,locy);
	add(gg,BorderLayout.CENTER);
	setBackground(Color.white);
	
	pack();

	// try { Thread.sleep(3000);} catch(Exception e) {System.out.println("sleep exception: "+e.getMessage());}
	show();
    }
    public GraphWindow(String titl, MotherGraph mgraph, 
		       int locx, int locy, boolean seq) {
	super(titl);
	gg=new GraphGui(mgraph,seq);

	setLocation(locx,locy);
	add(gg,BorderLayout.CENTER);

	pack();

	// try { Thread.sleep(3000);} catch(Exception e) {System.out.println("sleep exception: "+e.getMessage());}
	show();
    }

    public void setAndShowHighlight(Subgraph s) {
	gg.setAndShowHighlight(s);
    }

}
