/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;


/** An NSVCBagIRDifference is the result of applying an {@link NSVCBagIR} to a
    non-sequential similarity statement. */
public class NSVCBagIRDifference extends ViewDifference {

    int matchSize=-1;
    int bag1size=-1;
    int bag2size=-1;
    int bagLength=-1;
    double seqRating=-1.0;
    double sizePenalty=-1.0;
    double seqRatingBagLength2=-1.0;
    double ratingForVertices=-1.0;
    double ratingSimEdges=-1.0;

    public NSVCBagIRDifference(double v, NonSeqViewComparator or) {
	super(v,or);
    }

    public NSVCBagIRDifference(double v, NonSeqViewComparator or,
			       int match, int bag1, int bag2,
			       int bagLen, double sizePen,
			       double rating, double rating2, 
			       double ratingVertices, double ratingSim
			       ) {
	super(v,or);
	matchSize=match;
	bag1size=bag1;
	bag2size=bag2;
	bagLength=bagLen;
	seqRating=rating;
	sizePenalty=sizePen;
	seqRatingBagLength2=rating2;
	ratingForVertices=ratingVertices;
	ratingSimEdges=ratingSim;
    }

    public String toString(){
	String result="";
	result+="Size Penalty="+sizePenalty+"\n";
	result+="\tSequence rating, BagLength="+bagLength+"="+seqRating+"\n";
	result+="\t{ Match size="+matchSize+"\n";
	result+="\t  Bag 1 size="+bag1size+"\n";
	result+="\t  Bag 2 size="+bag2size+" }\n";
	//	result+="\tBag length="+bagLength+"\n";
	result+="\tSequence rating, BagLength=2="+seqRatingBagLength2+"\n";
	result+="\tSequence rating for Vertices="+ratingForVertices+"\n";
	result+="\tSequence rating for SimEdges="+ratingSimEdges+"";
	return result;
    }
    
}
