/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** NSVCVertex is extended and instantiated in {@link SimLibVertex}.*/
public abstract class NSVCVertex extends NonSeqViewComparator {

    public NSVCVertex(String s) {
	super(s);
    }
    
    protected abstract double compareVertices(MusicVertex mv1,
					      MusicVertex mv2,
					      NonSeqSimStmt nsss);

    protected double[][] getVertexSimMatrix(NonSeqSimStmt nsss) {
	/* for all vertices in graph 1, compare with all vertices in
           graph 2 */
	double[][] vertexSimilarities = new double[nsss.subgraph1.vertices.size()][nsss.subgraph2.vertices.size()];

	for (int i=0; i<nsss.subgraph1.vertices.size(); i++) {
	    MusicVertex mv1 = (MusicVertex) nsss.subgraph1.vertices.get(i);
	    for (int j=0; j<nsss.subgraph2.vertices.size(); j++) {
		MusicVertex mv2 = (MusicVertex) nsss.subgraph2.vertices.get(j);
		vertexSimilarities[i][j]=compareVertices(mv1,mv2,nsss);
	    }
	    // System.out.print("."); //tmp
	}
	return vertexSimilarities;
    }

  
}
