/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** An NSVDEdge is the result of applying an {@link NSVCEdge} to a
    non-sequential similarity statement. */
public class NSVDEdge extends ViewDifference {
    double [][] similarities=null;

    final int doubleStringLength = 4; // for toString formatting

    public int noEdgeSubgraphs() {
	if (similarities.length==0) return 2;
	else if (similarities[0].length==0) return 1;
	else return 0;
    }

    public boolean empty() {
	return (noEdgeSubgraphs()>0);
    }

    public NSVDEdge(double v, NonSeqViewComparator or) {
	super(v,or);
    }

    public NSVDEdge(double v, NonSeqViewComparator or, 
		      double[][] sims) {
	super(v,or);
	similarities=sims;
    }

    public String toString() {
	String result="";
	result += "\tEdge SimMatrix=\n"+similaritiesToString(similarities);

	return result;
    }
    public static String doubleToStringOfLength(double d, int length) {
	String result = Double.toString(d);
	if (result.length()>length) result =result.substring(0,length);
	if (result.length()<length) {
	    String s="";
	    for (int i=0; i<length-result.length(); i++) {
		s+=" ";
	    }
	    result = s+result;
	}
	result = "["+result+"]";
	return result;
    }

    private String similaritiesToString(double[][] sim) {
	String result="";
	for (int i=0; i</*subgraph1.size()*/ sim.length; i++) {
	    result+="\t";
	    for (int j=0; j</*subgraph2.size()*/sim[0].length; j++) {
		result+=doubleToStringOfLength(sim[i][j],
					       doubleStringLength);
	    }
	    result+="\n";
	}
	return result;
    }

}
