/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** An NSVDVertex is the result of applying an {@link NSVCVertex} to a
    non-sequential similarity statement. */
public class NSVDVertex extends ViewDifference {
    public double [][] similarities=null;
    final int doubleStringLength = 4; // for toString formatting

    public NSVDVertex(double v, NonSeqViewComparator or) {
	super(v,or);
    }

    public NSVDVertex(double v, NonSeqViewComparator or, 
		      double[][] sims) {
	super(v,or);
	similarities=sims;
    }

    public String toString() {
	String result="";
	result += "\tSimilarities matrix=\n"+similaritiesToString();
	return result;
    }
    public static String doubleToStringOfLength(double d, int length) {
	String result = Double.toString(d);
	if (result.length()>length) result =result.substring(0,length);
	if (result.length()<length) {
	    String s="";
	    for (int i=0; i<length-result.length(); i++) {
		s+=" ";
	    }
	    result = s+result;
	}
	result = "["+result+"]";
	return result;
    }

    private String similaritiesToString() {
	String result="";
	for (int i=0; i</*subgraph1.size()*/ similarities.length; i++) {
	    result+="\t";
	    for (int j=0; j</*subgraph2.size()*/similarities[0].length; j++) {
		result+=doubleToStringOfLength(similarities[i][j],
					       doubleStringLength);
	    }
	    result+="\n";
	}
	return result;
    }

}
