/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** A Nonterminal is what groups together a set of {@link
    GraphProductionRule}s describing productions of the same motif or
    derivations thereof. */

public class Nonterminal {
    /** A Vector of GraphProductionRules that describe productions of
        the same motif or derivations thereof. */
    public Vector prodRules; /* of GraphProductionRules */

    /** A label to identify this Nonterminal.*/
    public String name;
    /** The {@link SimilarityMeasure} which was used to locate a
        similarity that gave rise to this Nonterminal. */
    public SimilarityMeasure simMeasure;

    public Nonterminal(String nam, SimilarityMeasure sm) {
	name=nam;
	prodRules=new Vector();
	simMeasure = sm;
    }

    public String toString() {
	return name;
    }

}
