/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.awt.*;
import java.util.Vector;
import java.awt.event.*;
import jm.music.data.*;
import jm.util.*;
import jm.gui.show.*;

/** A GUI-related class for showing lists of {@link
    GraphProductionRule}s. */

public class ProdRuleList extends Frame implements ActionListener, 
						MouseListener,
						ItemListener {

    // MotherGraph piece;
    List ssList;
    /*    Button playButton;
    Button writeButton;
    Button runButton;
    Button stopButton;
    TextField runText;*/
    Vector rules;
    //GraphWindow gg1,gg2;
    //VertexUsageGui vug;
    TextArea ta;
    // boolean seq=true;
    // GraphProductionRule best=null;
    String statusFileName;
    // boolean stopRequest=false;

    ProdRuleGui[] prgui;
    ProdRuleGui currentPrg=null;

    public ProdRuleList(Vector daRules/* of GraphProductionRules */, 
			int locx, int locy) {
	rules=daRules;
	// super("List of subgraphs for "+piece.title);
	if (rules.size()==0) {
	    System.out.println("Empty rule vector passed to ProdRuleList");
	    System.exit(0);
	}
	// GraphProductionRule ss = (GraphProductionRule) daRules.get(0);
	/* in occurrence search subgraph1's mothergraph is not the
	   real mothergraph, but subgraph2's is!  (subgraph1 is no
	   longer in the real mothergraph since it has been
	   substituted with a compound) */
	// piece = ss.subgraph2.getMotherGraph();
	setLocation(locx,locy-100);

	ssList = new List(rules.size(),false);
	updateList(ssList,rules);
	ssList.addActionListener(this);
	ssList.addItemListener(this);
	// ssList.setSize(300,600);
	ta=new TextArea("",15,40);
	/*playButton=new Button("Play");
	playButton.addActionListener(this);

	writeButton=new Button("Write");
	writeButton.addActionListener(this);

	runButton=new Button("Run");
	runButton.addActionListener(this);

	stopButton=new Button("Stop");
	stopButton.addActionListener(this);

	runText=new TextField("1",4);
	*/
	setLayout(new BorderLayout());
	prgui = new ProdRuleGui[rules.size()];
	addMouseListener(this);
	add(ssList,BorderLayout.CENTER);
	add(ta, BorderLayout.SOUTH);

	prgui[0] = new ProdRuleGui((GraphProductionRule)rules.get(0));
	add(prgui[0],BorderLayout.EAST);

	//showRuleAtIndex(0);
	
	/*Container c = new Container();
	c.setLayout(new GridLayout(5,1));
	c.add(playButton);
	c.add(writeButton);
	c.add(runText);
	c.add(runButton);
	c.add(stopButton);
	add(c,BorderLayout.WEST);*/
	
	pack();
	setSize(900,700);
	// setSize(580,800);
	show();
    }

    public void showRuleAtIndex(int index) {
	    if (prgui[index]==null) {
		GraphProductionRule pr = (GraphProductionRule) rules.get(index);
		prgui[index]=new ProdRuleGui(pr);
	    }
	    if (currentPrg!=null)
		remove(currentPrg);
	    add(prgui[index],BorderLayout.EAST);
	    currentPrg=prgui[index];
	    pack();
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getSource()==ssList) {
	    int index = ssList.getSelectedIndex();
	    showRuleAtIndex(index);
	}	    
	/*	else if (e.getSource()==playButton) {
	    int index = ssList.getSelectedIndex();
	    GraphProductionRule ss = (GraphProductionRule) rules.get(index);
	    gg1.setAndShowHighlight(ss.subgraph1);
	    gg2.setAndShowHighlight(ss.subgraph2);
	    ta.setText("Playing subgraph 1");
	    Score s;
	    if (seq) s=ss.subgraph1.convertToScore();
	    else s=ss.subgraph1.convertToScore();
	    playScore(s);
	    
	    try {Thread.sleep(2000);}
	    catch(Exception exc) { System.out.println("Sleep exception in graphlist: " +exc.getMessage());}

	    ta.setText("Playing subgraph 2");
	    if (seq) s=ss.subgraph2.convertToScore();
	    else s=ss.subgraph2.convertToScore();
	    playScore(s);
	    
	    try {Thread.sleep(2000);}
	    catch(Exception exc) { System.out.println("Sleep exception in graphlist: " +exc.getMessage());}
	    ta.setText("");
	    
	} else if (e.getSource()==writeButton) {
	    int index = ssList.getSelectedIndex();
	    GraphProductionRule ss = (GraphProductionRule) rules.get(index);
	    gg1.setAndShowHighlight(ss.subgraph1);
	    gg2.setAndShowHighlight(ss.subgraph2);
	    String writing="Writing: subgraph1.mid";
	    ta.setText(writing);
	    Score s;
	    if (seq) s=ss.subgraph1.convertToScore();
	    else s=ss.subgraph1.convertToScore();
	    writeScore(s,1);
	    ta.setText(writing+"\nWriting subgraph2.mid");
	    if (seq) s=ss.subgraph2.convertToScore();
	    else s=ss.subgraph2.convertToScore();
	    writeScore(s,2);
	    try {Thread.sleep(2000);}
	    catch(Exception exc) { System.out.println("Sleep exception in graphlist: " +exc.getMessage());}
	    ta.setText("");

	}else if(e.getSource()==runButton){
	    GraphProductionRule firstSimStmt=(GraphProductionRule) rules.get(0);
	    SimFinder sf = firstSimStmt.myOwner;
	    String input=(runText.getText()).trim();
	    int generations=new Integer(input).intValue();
	    for(int i=0;i<generations && !stopRequest;i++){
		try{
		    sf.run(1,"sf.out");
		}catch(Exception excptn){}
		rules=sf.rules;
		best=sf.findBest();
		updateList(ssList,rules,best);
		ssList.select(0);
		ta.setText(best.toStringWithSubgraphs());
		gg1.setAndShowHighlight(best.subgraph1);
		gg2.setAndShowHighlight(best.subgraph2);
		show();
	    }
	    stopRequest=false;
	}else if(e.getSource()==runText){
	}else if(e.getSource()==stopButton){
	    stopRequest=true;

	    }*/
	else {
	    System.out.println("Debug: Got ActionEvent from unexpected source:"+e.getSource().toString());
	}
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange()==ItemEvent.SELECTED) {
	    int index = ssList.getSelectedIndex();
	    //	    ta.setText(((GraphProductionRule)rules.get(index)).
	    GraphProductionRule ss = ((GraphProductionRule)rules.get(index));
	    ta.setText(ss.toString());
	} else {
	    System.out.println("Debug: ItemEvent != ItemEvent.SELECTED");
	}
    }

    public void mousePressed(MouseEvent e) {
	// huh
    }
    public void mouseReleased(MouseEvent e) {
	// huh
    }
    public void mouseEntered(MouseEvent e) {
	// huh
    }
    public void mouseExited(MouseEvent e) {
	// huh
    }

    public void mouseClicked(MouseEvent e) {
	/* MusicGraph mg = (MusicGraph) highlights.get(0);
	if (e.getButton()==MouseEvent.BUTTON1) {
	    try {mg.shortenRight(1);}
	    catch(Exception ex) { System.out.println(ex.getMessage());}
	}
	else if (e.getButton()==MouseEvent.BUTTON2) {
	    System.out.println("Hah, mouse button 2 has no effect!");
	}
	else if (e.getButton()==MouseEvent.BUTTON3) {
	    try {mg.extendRight(1);}
	    catch(Exception ex) { System.out.println(ex.getMessage());}
	}
	showSubgraph(mg);*/ 
    }

    private void updateList(List l, Vector rulez){
	l.removeAll();
	for (int i=0; i<rulez.size(); i++) {
	    GraphProductionRule sims = (GraphProductionRule) rulez.get(i);
	    String str = i+" ";
	    str+= sims.toString();
	    l.add(str);
	}
	// vug.updateColours();
    }

    public void simFinderCallBack(){
	
    }
	
}
