/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.awt.*;
import java.util.Vector;
import java.awt.event.*;

/** A GUI-related class used to show a GraphProductionRule in a
    separate window. */

public class ProdRuleWindow extends Frame {

    GraphGui left;
    GraphGui right;
    GraphProductionRule gprule;

    public ProdRuleWindow(GraphProductionRule gpr, int locx, int locy, boolean seq) {
	super(gpr.toString());
	left=new GraphGui(gpr.leftside.getMotherGraph(),seq);
	right=new GraphGui(gpr.rightside.getMotherGraph(),seq);

	setLocation(locx,locy);
	add(left,BorderLayout.NORTH);
	add(right,BorderLayout.SOUTH);

	pack();

	// try { Thread.sleep(3000);} catch(Exception e) {System.out.println("sleep exception: "+e.getMessage());}
	show();
    }

}
