/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** An instance of SimMeasureResult is the result of the evaluation of
    a SimilarityStatement.*/
public class SimMeasureResult {

    /** A Vector containing the individual results obtained from all
        view comparators used in the originating SimilarityMeasure. */
    public Vector viewDifferences = new Vector(); // of ViewDifference
    /** The originating SimilarityMeasure. */
    public SimilarityMeasure origin=null;
    /** The main value resulting from the evaluation. */
    public double measure=-1.0;
    public double measureNoOverlap=-1.0;

    public SimMeasureResult(double meas, SimilarityMeasure or) {
	measure=meas;
	origin=or;
    }
    public SimMeasureResult(double meas, Vector vpr, SimilarityMeasure or) {
	viewDifferences=vpr;
	measure=meas;
	origin=or;
    }

    public String toString() {
	String result = "";
	if (origin!=null) result+= origin.name+" = "+measure;
	return result;
    }

    public String toStringWithViewDifferences() {
	String result = toString()+"\n";
	for (int i=0; i<viewDifferences.size(); i++) {
	    ViewDifference vpr = (ViewDifference) viewDifferences.get(i);
	    result +="\t"+vpr.toString()+"\n";
	}

	return result;
    }

    public String toGnuplotString() {
	String result ="";
	for (int i=0; i<viewDifferences.size(); i++) {
	    ViewDifference vpr = (ViewDifference) viewDifferences.get(i);
	    result += " "+vpr.toGnuplotString();
	}
	return result;
    }

    public String toGnuplotHeader() {
	String result ="";
	for (int i=0; i<viewDifferences.size(); i++) {
	    ViewDifference vpr = (ViewDifference) viewDifferences.get(i);
	    result += " "+vpr.toGnuplotHeader();
	}
	return result;
    }

}
