/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.util.Vector;

/** This is one of the three classes comprising the example of how to
    extend the SimFinder system. See also {@link
    StartSimSegmenterExample} and {@link SimLibExample}. */
public class StartSimFinderExample {

    // Inventio1.md2 is a good choise as argument
    
    public static void main(String[] args){
	if(args.length!=1){
	    System.out.println("Usage: java StartSimFinderExample <musedatafile>");
	    System.exit(0);
	}

	MotherGraph mother = new MotherGraph(args[0],
					     false, //interpartEdges
					     false, //combineTies
					     false //combineRests
				);
	try{
	    SimFinder sf = new SimFinder(mother,//filename
					 100,//popsize
					 5,//init size
					 0.05,//co
					 0.4, //mut
					 10,//report freq
					 SimLibExample.seqDiatonicRetrogradeInterval,
					 null,//occurrence
					 0,  //maxSize
					 0.4, //freshBloodChance
					 0.5//groupBase 
				     );
	    sf.run(300,"StartSimFinderExample.out");
	    sf.showPopulation();
	    
	}catch(Exception ex){}
    }

}
