/* Copyright (C) 2003 Sren Tjagvad Madsen & Martin Elmer Jrgensen
 * email: {tjagvad,elmer}@daimi.au.dk */

import java.io.*;

/** This is one of the three classes comprising the example of how to
    extend the SimFinder system. See also {@link
    StartSimFinderExample} and {@link SimLibExample}. */

public class StartSimSegmenterExample{
    
    // Inventio1.md2 is a good choise as argument
    
    public static void main(String[] args) throws Exception{
	if(args.length!=1){
	    System.out.println("Usage: java StartSimSegmenterExample <musedatafile>");
	    System.exit(0);
	}
	
	SimilarityMeasure[] measure = {
	    SimLibExample.seqDiatonicRetrogradeInterval
	};

	
	SimSegmenter segm = new SimSegmenter(args[0],
					     false, // interpartEdges
					     false, // combineTies
					     false, // combineRests
					     measure,
					     0.01, // crossover
					     0.5, // mutation
					     5, // initsize
					     80, // popsize
					     10, // repFreq
					     "sf.out", // outfilename
					     200, // simGens
					     0, // occGens
					     1.0, // limit
					     0, // maxsize
					     0.1, //fresh blood chance - in mutation
					     -1, // gensAfterLimitReached
					     10, // gensPerLimitCheck
					     0.0 //groupBase-gamma
					     );
	segm.run();
	segm.showAllProductionRules(segm.prodRules);
	segm.show();
    }
}
